#ifndef BTFUNCTIONS_H_
#define BTFUNCTIONS_H_

/*
 * Global vars
 * 
 */

int 			semid;
key_t 			semkey;

/*
 * Prototypes
 * 
 */

/*
 *  blueprinting.c
 */
bp_sdp_t*		sdp_get_attribs_from_record(sdp_data_t*, unsigned int,bp_sdp_t*);
int 			sdp_get_opush_channel(sdp_data_t*, unsigned int, int, char, int*);
bp_sdp_t*		add_to_bp_list(bp_sdp_t*, unsigned int, unsigned char, void*, unsigned int);
void 			free_bp_list(bp_sdp_t*);
void 			get_sdp_id(bp_sdp_t*, bp_sdp_chunks_t*);
void 			get_sdp_obex_id(bp_sdp_t*, bp_sdp_chunks_t*, int channel);
void 			get_hci_id(bdaddr_t *, struct hci_version *, unsigned char *, bp_hci_chunks_t *);
void 			print_hci_id(bdaddr_t*, struct hci_version*, unsigned char*);
void 			print_sdp_id(bp_sdp_t*);
void 			print_hci_id_html(bdaddr_t*, struct hci_version*, unsigned char*);
void 			print_sdp_id_html(bp_sdp_t*, char*);
void 			free_hci_chunks(bp_hci_chunks_t *);
void 			free_sdp_chunks(bp_sdp_chunks_t *);
device_t *  	get_device(bp_hci_chunks_t *, bp_sdp_chunks_t *, int, bdaddr_t * );
void 			free_device(device_t *);
void 			free_device_caps(device_caps_t *);

/*
 * bluepush.c
 */
int 			obex_push(char*, char*, char*, mydevices_t *, founddevices_t *);


/*
 * bluedevices.c
 */
bdaddr_t * 		my_str2ba(char *);
char * 			my_ba2str(bdaddr_t *);
int 			my_bacmp(bdaddr_t *, bdaddr_t *);
mydevices_t * 	add_local_device(mydevices_t *, int, char);
int 			is_local_device (mydevices_t *, bdaddr_t *);
void 			dump_local_devices(mydevices_t *);
mydevices_t * 	get_free_local_device(mydevices_t *, char);
void 			add_remote_device(founddevices_t **, device_t *, char);
void 			dump_remote_devices(founddevices_t **);
int 			is_already_in_list(founddevices_t **, bdaddr_t *);
void 			add_locked_device(lockeddevices_t **, bdaddr_t *);
void 			remove_locked_device(lockeddevices_t **, bdaddr_t *);
int 			is_locked(lockeddevices_t **, bdaddr_t *);
founddevices_t *get_remote_device(founddevices_t **, char, time_t);
void 			cleanup_expired_remote_devices(founddevices_t **, lockeddevices_t **, time_t);
void 			dump_locked_devices(lockeddevices_t **);
void 			free_local_devices(mydevices_t *);
void 			free_locked_devices(lockeddevices_t **, lockeddevices_t *);
//int				supports_content_type(device_t *, char *);
void 			load_blocked_devices(founddevices_t **);
int				get_content_for_device(device_t *, char *, char *, char *, char *, char*);

/*
 * bluethreads.c
 */
void *			thread_scan (void *);
void *			thread_push (void *);

#endif /*BTFUNCTIONS_H_*/
